Add MANDIR to defs files.
diff -uNr Linux-PAM-0.75/defs/debian.defs Linux-PAM-0.75/defs/debian.defs
--- Linux-PAM-0.75/defs/debian.defs	Tue Jun 20 18:10:46 2000
+++ Linux-PAM-0.75/defs/debian.defs	Tue Jul 10 00:14:23 2001
@@ -25,6 +25,7 @@
 RANLIB		:= ranlib
 PREFIX		:=
 LIBDIR		:= $(PREFIX)/lib
+MANDIR		:= $(PREFIX)/man
 USESONAME	:= yes
 SOSWITCH	:= -soname
 LINKLIBS	:= -lc -L${shell pwd}/libpam -L${shell pwd}/libpam_misc
diff -uNr Linux-PAM-0.75/defs/hpux.defs Linux-PAM-0.75/defs/hpux.defs
--- Linux-PAM-0.75/defs/hpux.defs	Tue Jun 20 18:10:46 2000
+++ Linux-PAM-0.75/defs/hpux.defs	Tue Jul 10 00:14:23 2001
@@ -27,6 +27,7 @@
 PREFIX=/usr
 SUPLEMENTED=$(PREFIX)/sbin
 LIBDIR=$(PREFIX)/lib
+MANDIR=$(PREFIX)/man
 SECUREDIR=$(LIBDIR)/security
 INCLUDED=/usr/include/security
 CONFIGED=/etc
diff -uNr Linux-PAM-0.75/defs/linux.defs Linux-PAM-0.75/defs/linux.defs
--- Linux-PAM-0.75/defs/linux.defs	Tue Jun 20 18:10:46 2000
+++ Linux-PAM-0.75/defs/linux.defs	Tue Jul 10 00:14:23 2001
@@ -26,6 +26,7 @@
 PREFIX=/usr
 SUPLEMENTED=$(PREFIX)/sbin
 LIBDIR=$(PREFIX)/lib
+MANDIR=$(PREFIX)/man
 SECUREDIR=$(LIBDIR)/security
 INCLUDED=/usr/include/security
 CONFIGED=/etc
diff -uNr Linux-PAM-0.75/defs/morgan.defs Linux-PAM-0.75/defs/morgan.defs
--- Linux-PAM-0.75/defs/morgan.defs	Tue Jun 20 18:10:46 2000
+++ Linux-PAM-0.75/defs/morgan.defs	Tue Jul 10 00:14:23 2001
@@ -30,6 +30,7 @@
 PREFIX=
 SUPLEMENTED=$(PREFIX)/sbin
 LIBDIR=$(PREFIX)/lib
+MANDIR=$(PREFIX)/man
 SECUREDIR=$(LIBDIR)/security.d
 INCLUDED=/usr/include/security
 CONFIGED=/etc
diff -uNr Linux-PAM-0.75/defs/redhat.defs Linux-PAM-0.75/defs/redhat.defs
--- Linux-PAM-0.75/defs/redhat.defs	Tue Jun 20 18:10:46 2000
+++ Linux-PAM-0.75/defs/redhat.defs	Tue Jul 10 00:14:23 2001
@@ -9,17 +9,16 @@
 # This file is the version used for Red Hat Linux.
 
 OS=linux
-ARCH=$(shell rpm --showrc | grep '^build arch' | sed 's/^.*: //g')
 CC=gcc
 INSTALL=install
 MKDIR=mkdir -p
-CFLAGS=$(RPM_OPT_FLAGS) -pipe -g
+CFLAGS=$(RPM_OPT_FLAGS) -DPAM_READ_BOTH_CONFS
 ULIBS=#-lefence
-LD=ld
+LD=gcc
 LD_D=gcc -shared -Xlinker -x
-LD_L=$(LD) -x -shared 
+LD_L=$(LD_D)
 USESONAME=yes
-SOSWITCH=-soname
+SOSWITCH=-Wl,-soname
 LINKLIBS=-lc
 NEEDSONAME=no
 LDCONFIG=/sbin/ldconfig
@@ -29,6 +28,7 @@
 PREFIX=
 SUPLEMENTED=$(PREFIX)/sbin
 LIBDIR=$(PREFIX)/lib
+MANDIR=/usr/share/man
 SECUREDIR=$(LIBDIR)/security
 INCLUDED=/usr/include/security
 CONFIGED=/etc
diff -uNr Linux-PAM-0.75/defs/redhat4.defs Linux-PAM-0.75/defs/redhat4.defs
--- Linux-PAM-0.75/defs/redhat4.defs	Tue Jun 20 18:10:46 2000
+++ Linux-PAM-0.75/defs/redhat4.defs	Tue Jul 10 00:14:23 2001
@@ -29,6 +29,7 @@
 PREFIX=
 SUPLEMENTED=$(PREFIX)/sbin
 LIBDIR=$(PREFIX)/lib
+MANDIR=$(PREFIX)/man
 SECUREDIR=$(LIBDIR)/security
 INCLUDED=/usr/include/security
 CONFIGED=/etc
diff -uNr Linux-PAM-0.75/defs/solaris-2.1.5.defs Linux-PAM-0.75/defs/solaris-2.1.5.defs
--- Linux-PAM-0.75/defs/solaris-2.1.5.defs	Tue Jun 20 18:10:46 2000
+++ Linux-PAM-0.75/defs/solaris-2.1.5.defs	Tue Jul 10 00:14:23 2001
@@ -39,6 +39,7 @@
 PREFIX=/usr
 SUPLEMENTED=$(PREFIX)/sbin
 LIBDIR=$(PREFIX)/lib
+MANDIR=$(PREFIX)/man
 SECUREDIR=$(LIBDIR)/security
 INCLUDED=/usr/include/security
 CONFIGED=/etc
diff -uNr Linux-PAM-0.75/defs/solaris.defs Linux-PAM-0.75/defs/solaris.defs
--- Linux-PAM-0.75/defs/solaris.defs	Tue Jun 20 18:10:46 2000
+++ Linux-PAM-0.75/defs/solaris.defs	Tue Jul 10 00:14:23 2001
@@ -42,6 +42,7 @@
 PREFIX=/usr
 SUPLEMENTED=$(PREFIX)/sbin
 LIBDIR=$(PREFIX)/lib
+MANDIR=$(PREFIX)/man
 SECUREDIR=$(LIBDIR)/security
 INCLUDED=/usr/include/security
 CONFIGED=/etc
diff -uNr Linux-PAM-0.75/defs/sunos.defs Linux-PAM-0.75/defs/sunos.defs
--- Linux-PAM-0.75/defs/sunos.defs	Tue Jun 20 18:10:46 2000
+++ Linux-PAM-0.75/defs/sunos.defs	Tue Jul 10 00:14:23 2001
@@ -27,6 +27,7 @@
 PREFIX=/usr
 SUPLEMENTED=$(PREFIX)/sbin
 LIBDIR=$(PREFIX)/lib
+MANDIR=$(PREFIX)/man
 SECUREDIR=$(LIBDIR)/security
 INCLUDED=/usr/include/security
 CONFIGED=/etc
diff -uNr Linux-PAM-0.75/defs/suse.defs Linux-PAM-0.75/defs/suse.defs
--- Linux-PAM-0.75/defs/suse.defs	Tue Jun 20 18:10:46 2000
+++ Linux-PAM-0.75/defs/suse.defs	Tue Jul 10 00:14:23 2001
@@ -29,6 +29,7 @@
 PREFIX=
 SUPLEMENTED=$(PREFIX)/sbin
 LIBDIR=$(PREFIX)/lib
+MANDIR=$(PREFIX)/man
 SECUREDIR=$(LIBDIR)/security
 INCLUDED=/usr/include/security
 CONFIGED=/etc
diff -uNr Linux-PAM-0.75/doc/Makefile Linux-PAM-0.75/doc/Makefile
--- Linux-PAM-0.75/doc/Makefile	Mon Jan 22 03:03:01 2001
+++ Linux-PAM-0.75/doc/Makefile	Tue Jul 10 00:14:23 2001
@@ -5,7 +5,7 @@
 
 # These two should probably be moved into autoconf...
 DOCDIR=/usr/doc/Linux-PAM
-MANDIR=/usr/man
+MANDIR=$(mandir)
 
 #######################################################
 