diff -Naur Linux-PAM-0.75.orig/configure.in Linux-PAM-0.75/configure.in
--- Linux-PAM-0.75.orig/configure.in	Tue Jul 15 07:06:16 2003
+++ Linux-PAM-0.75/configure.in	Tue Jul 15 07:22:54 2003
@@ -244,10 +244,10 @@
 CRACKLIB_DICTPATH=""
 for d in $DICT_DIR_CANDIDATES ; do
       for f in $DICT_FILE_CANDIDATES ; do
-              if test -r $d/$f.hwm ; then
+              if test -r $ELDK_ROOT/$ELDK_TARGET/$d/$f.hwm ; then
                       CRACKLIB_DICTPATH=$d/$f
                       break 2
-              elif test -r $d/dict/$f.hwm ; then
+              elif test -r $ELDK_ROOT/$ELDK_TARGET/$d/dict/$f.hwm ; then
                       CRACKLIB_DICTPATH=$d/dict/$f
                       break 2
               fi
diff -Naur Linux-PAM-0.75.orig/doc/Makefile Linux-PAM-0.75/doc/Makefile
--- Linux-PAM-0.75.orig/doc/Makefile	Tue Jul 15 07:06:16 2003
+++ Linux-PAM-0.75/doc/Makefile	Tue Jul 15 07:20:26 2003
@@ -118,7 +118,8 @@
 	  install -m 644 $$file $(FAKEROOT)$(DOCDIR)/html ; \
 	done
 endif
-	mkdir -p $(FAKEROOT)$(MANDIR)/man{3,8}
+	mkdir -p $(FAKEROOT)$(MANDIR)/man3
+	mkdir -p $(FAKEROOT)$(MANDIR)/man8
 	for file in man/*.3 ; do \
 	  install -m 644 $$file $(FAKEROOT)$(MANDIR)/man3 ; \
 	done
diff -Naur Linux-PAM-0.75.orig/modules/pam_console/Makefile Linux-PAM-0.75/modules/pam_console/Makefile
--- Linux-PAM-0.75.orig/modules/pam_console/Makefile	Wed Sep  5 02:08:45 2001
+++ Linux-PAM-0.75/modules/pam_console/Makefile	Tue Jul 15 07:16:35 2003
@@ -10,7 +10,7 @@
 
 LOCKDIR = /var/run/console
 LOCKMODE = 755
-LIBS +=  $(shell glib-config --libs)
+LIBS +=  -lglib
 LDFLAGS = $(LIBS)
 
 BINARY = pam_console_apply
@@ -20,7 +20,8 @@
 MAN5 = console.apps.5 console.perms.5
 MAN8 = pam_console.8 pam_console_apply.8
 
-CFLAGS += $(shell glib-config --cflags) -D_GNU_SOURCE -DLOCKDIR=\"$(LOCKDIR)\"
+CFLAGS += -I$(ELDK_ROOT)/$(ELDK_TARGET)/usr/lib/glib/include \
+          -D_GNU_SOURCE -DLOCKDIR=\"$(LOCKDIR)\"
 
 FLEX_OPTS = -Cr
 BISON_OPTS = -d
diff -Naur Linux-PAM-0.75.orig/modules/pam_console/console.perms Linux-PAM-0.75/modules/pam_console/console.perms
--- Linux-PAM-0.75.orig/modules/pam_console/console.perms	Tue Jul 15 07:06:16 2003
+++ Linux-PAM-0.75/modules/pam_console/console.perms	Tue Jul 15 07:19:09 2003
@@ -15,7 +15,7 @@
 # man 5 console.perms
 
 # file classes -- these are regular expressions
-<console>=tty[0-9][0-9]* vc/[0-9][0-9]* :[0-9]\.[0-9] :[0-9]
+<console>=ttyS[0-9][0-9]* vc/[0-9][0-9]* :[0-9]\.[0-9] :[0-9]
 <xconsole>=:[0-9]\.[0-9] :[0-9]
 
 # device classes -- these are shell-style globs
diff -Naur Linux-PAM-0.75.orig/modules/pam_limits/Makefile Linux-PAM-0.75/modules/pam_limits/Makefile
--- Linux-PAM-0.75.orig/modules/pam_limits/Makefile	Tue Jul 15 07:06:16 2003
+++ Linux-PAM-0.75/modules/pam_limits/Makefile	Tue Jul 15 07:21:41 2003
@@ -10,7 +10,7 @@
 
 TITLE=pam_limits
 
-ifeq ($(OS),linux)
+#ifeq ($(OS),linux)
 
 LOCAL_CONFILE=./limits.skel
 INSTALLED_CONFILE=$(SCONFIGD)/limits.conf
@@ -27,8 +27,8 @@
 #else
 #include ../dont_makefile
 #endif
-else
+#else
 
-include ../dont_makefile
+#include ../dont_makefile
 
-endif
+#endif
diff -Naur Linux-PAM-0.75.orig/modules/pam_unix/Makefile Linux-PAM-0.75/modules/pam_unix/Makefile
--- Linux-PAM-0.75.orig/modules/pam_unix/Makefile	Tue Jul 15 07:06:16 2003
+++ Linux-PAM-0.75/modules/pam_unix/Makefile	Tue Jul 15 07:17:39 2003
@@ -18,7 +18,7 @@
 #USE_CRACKLIB=-D"USE_CRACKLIB"
 #endif
 
-ifeq ($(shell if [ -f /usr/lib/cracklib_dict.hwm ]; then echo yes ; fi),yes)
+ifeq ($(shell if [ -f $(ELDK_ROOT)/$(ELDK_TARGET)/usr/lib/cracklib_dict.hwm ]; then echo yes ; fi),yes)
  CRACKLIB_DICTPATH=/usr/lib/cracklib_dict
 else
  CRACKLIB_DICTPATH=/usr/share/dict/cracklib_dict
diff -Naur Linux-PAM-0.75.orig/modules/pam_unix/Makefile.bigcrypt-main Linux-PAM-0.75/modules/pam_unix/Makefile.bigcrypt-main
--- Linux-PAM-0.75.orig/modules/pam_unix/Makefile.bigcrypt-main	Tue Jul 15 07:06:16 2003
+++ Linux-PAM-0.75/modules/pam_unix/Makefile.bigcrypt-main	Tue Jul 15 07:18:26 2003
@@ -18,7 +18,7 @@
 #USE_CRACKLIB=-D"USE_CRACKLIB"
 #endif
 
-ifeq ($(shell if [ -f /usr/lib/cracklib_dict.hwm ]; then echo yes ; fi),yes)
+ifeq ($(shell if [ -f $(ELDK_ROOT)/$(ELDK_TARGET)/usr/lib/cracklib_dict.hwm ]; then echo yes ; fi),yes)
  CRACKLIB_DICTPATH=/usr/lib/cracklib_dict
 else
  CRACKLIB_DICTPATH=/usr/share/dict/cracklib_dict
diff -Naur Linux-PAM-0.75.orig/pwdb-0.62/libpwdb/Makefile Linux-PAM-0.75/pwdb-0.62/libpwdb/Makefile
--- Linux-PAM-0.75.orig/pwdb-0.62/libpwdb/Makefile	Sat Apr 10 13:31:20 1999
+++ Linux-PAM-0.75/pwdb-0.62/libpwdb/Makefile	Tue Jul 15 07:14:29 2003
@@ -70,6 +70,7 @@
 	$(INSTALL) -m 755 $(LIBFILENAME) $(LIBDIR)
 	$(LDCONFIG)
 	ln -sf $(LIBFILENAME) $(LIBDIR)/$(LIBDYNAME)
+	ln -sf $(LIBFILENAME) $(LIBDIR)/$(LIBSONAME)
 	$(INSTALL) -m 644 $(LIBSTATIC) $(LIBDIR)
 
 clean: